# coding: utf-8

"""
    Cythereal Dashboard API

     The API used exclusively by the MAGIC Dashboard for populating charts, graphs, tables, etc... on the dashboard.  # API Conventions  **All responses** MUST be of type `APIResponse` and contain the following fields:  * `api_version` |  The current api version * `success` | Boolean value indicating if the operation succeeded. * `code` | Status code. Typically corresponds to the HTTP status code.  * `message` | A human readable message providing more details about the operation. Can be null or empty.  **Successful operations** MUST return a `SuccessResponse`, which extends `APIResponse` by adding:  * `data` | Properties containing the response object. * `success` | MUST equal True  When returning objects from a successful response, the `data` object SHOULD contain a property named after the requested object type. For example, the `/alerts` endpoint should return a response object with `data.alerts`. This property SHOULD  contain a list of the returned objects. For the `/alerts` endpoint, the `data.alerts` property contains a list of MagicAlerts objects. See the `/alerts` endpoint documentation for an example.  **Failed Operations** MUST return an `ErrorResponse`, which extends `APIResponse` by adding:  * `success` | MUST equal False.   # noqa: E501

    OpenAPI spec version: 0.40.0
    Contact: support@cythereal.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class ProcessingReportListInnerObjCounts(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'binary_elf': 'int',
        'binary_pe32': 'int',
        'binary_unpacked': 'int'
    }

    attribute_map = {
        'binary_elf': 'binary-elf',
        'binary_pe32': 'binary-pe32',
        'binary_unpacked': 'binary-unpacked'
    }

    def __init__(self, binary_elf=None, binary_pe32=None, binary_unpacked=None):  # noqa: E501
        """ProcessingReportListInnerObjCounts - a model defined in Swagger"""  # noqa: E501

        self._binary_elf = None
        self._binary_pe32 = None
        self._binary_unpacked = None
        self.discriminator = None

        if binary_elf is not None:
            self.binary_elf = binary_elf
        if binary_pe32 is not None:
            self.binary_pe32 = binary_pe32
        if binary_unpacked is not None:
            self.binary_unpacked = binary_unpacked

    @property
    def binary_elf(self):
        """Gets the binary_elf of this ProcessingReportListInnerObjCounts.  # noqa: E501


        :return: The binary_elf of this ProcessingReportListInnerObjCounts.  # noqa: E501
        :rtype: int
        """
        return self._binary_elf

    @binary_elf.setter
    def binary_elf(self, binary_elf):
        """Sets the binary_elf of this ProcessingReportListInnerObjCounts.


        :param binary_elf: The binary_elf of this ProcessingReportListInnerObjCounts.  # noqa: E501
        :type: int
        """

        self._binary_elf = binary_elf

    @property
    def binary_pe32(self):
        """Gets the binary_pe32 of this ProcessingReportListInnerObjCounts.  # noqa: E501


        :return: The binary_pe32 of this ProcessingReportListInnerObjCounts.  # noqa: E501
        :rtype: int
        """
        return self._binary_pe32

    @binary_pe32.setter
    def binary_pe32(self, binary_pe32):
        """Sets the binary_pe32 of this ProcessingReportListInnerObjCounts.


        :param binary_pe32: The binary_pe32 of this ProcessingReportListInnerObjCounts.  # noqa: E501
        :type: int
        """

        self._binary_pe32 = binary_pe32

    @property
    def binary_unpacked(self):
        """Gets the binary_unpacked of this ProcessingReportListInnerObjCounts.  # noqa: E501


        :return: The binary_unpacked of this ProcessingReportListInnerObjCounts.  # noqa: E501
        :rtype: int
        """
        return self._binary_unpacked

    @binary_unpacked.setter
    def binary_unpacked(self, binary_unpacked):
        """Sets the binary_unpacked of this ProcessingReportListInnerObjCounts.


        :param binary_unpacked: The binary_unpacked of this ProcessingReportListInnerObjCounts.  # noqa: E501
        :type: int
        """

        self._binary_unpacked = binary_unpacked

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProcessingReportListInnerObjCounts, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProcessingReportListInnerObjCounts):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
