# coding: utf-8

"""
    Cythereal Dashboard API

     The API used exclusively by the MAGIC Dashboard for populating charts, graphs, tables, etc... on the dashboard.  # API Conventions  **All responses** MUST be of type `APIResponse` and contain the following fields:  * `api_version` |  The current api version * `success` | Boolean value indicating if the operation succeeded. * `code` | Status code. Typically corresponds to the HTTP status code.  * `message` | A human readable message providing more details about the operation. Can be null or empty.  **Successful operations** MUST return a `SuccessResponse`, which extends `APIResponse` by adding:  * `data` | Properties containing the response object. * `success` | MUST equal True  When returning objects from a successful response, the `data` object SHOULD contain a property named after the requested object type. For example, the `/alerts` endpoint should return a response object with `data.alerts`. This property SHOULD  contain a list of the returned objects. For the `/alerts` endpoint, the `data.alerts` property contains a list of MagicAlerts objects. See the `/alerts` endpoint documentation for an example.  **Failed Operations** MUST return an `ErrorResponse`, which extends `APIResponse` by adding:  * `success` | MUST equal False.   # noqa: E501

    OpenAPI spec version: 0.42.1
    Contact: support@cythereal.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class QuarantineBinaryListInner(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'sha1': 'Sha1',
        'family': 'Family',
        'top_level_files': 'list[QuarantineBinaryListInnerTopLevelFiles]'
    }

    attribute_map = {
        'sha1': 'sha1',
        'family': 'family',
        'top_level_files': 'top_level_files'
    }

    def __init__(self, sha1=None, family=None, top_level_files=None):  # noqa: E501
        """QuarantineBinaryListInner - a model defined in Swagger"""  # noqa: E501

        self._sha1 = None
        self._family = None
        self._top_level_files = None
        self.discriminator = None

        if sha1 is not None:
            self.sha1 = sha1
        if family is not None:
            self.family = family
        if top_level_files is not None:
            self.top_level_files = top_level_files

    @property
    def sha1(self):
        """Gets the sha1 of this QuarantineBinaryListInner.  # noqa: E501


        :return: The sha1 of this QuarantineBinaryListInner.  # noqa: E501
        :rtype: Sha1
        """
        return self._sha1

    @sha1.setter
    def sha1(self, sha1):
        """Sets the sha1 of this QuarantineBinaryListInner.


        :param sha1: The sha1 of this QuarantineBinaryListInner.  # noqa: E501
        :type: Sha1
        """

        self._sha1 = sha1

    @property
    def family(self):
        """Gets the family of this QuarantineBinaryListInner.  # noqa: E501


        :return: The family of this QuarantineBinaryListInner.  # noqa: E501
        :rtype: Family
        """
        return self._family

    @family.setter
    def family(self, family):
        """Sets the family of this QuarantineBinaryListInner.


        :param family: The family of this QuarantineBinaryListInner.  # noqa: E501
        :type: Family
        """

        self._family = family

    @property
    def top_level_files(self):
        """Gets the top_level_files of this QuarantineBinaryListInner.  # noqa: E501


        :return: The top_level_files of this QuarantineBinaryListInner.  # noqa: E501
        :rtype: list[QuarantineBinaryListInnerTopLevelFiles]
        """
        return self._top_level_files

    @top_level_files.setter
    def top_level_files(self, top_level_files):
        """Sets the top_level_files of this QuarantineBinaryListInner.


        :param top_level_files: The top_level_files of this QuarantineBinaryListInner.  # noqa: E501
        :type: list[QuarantineBinaryListInnerTopLevelFiles]
        """

        self._top_level_files = top_level_files

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(QuarantineBinaryListInner, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QuarantineBinaryListInner):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
